Subject: Re: e100 "Ferguson" release

From: "David S. Miller" <[email-masked]>
Date: Sun, 3 Aug 2003 21:13:33 -0700

On Sun, 03 Aug 2003 21:08:26 -0700
David Brownell <[email-masked]> wrote:

> No such callback.  If no resources, they fail -ENOMEM and the
> caller must recover.  Which is why hard_start_xmit() needs to
> do something.

I would suggest something different :-)

For example, what do USB block device drivers do when -ENOMEM comes
back?  Do they just drop the request on the floor?  No, rather they
resubmit the request later without the scsi/block layer knowing
anything about what happened, right?

How do the USB block device drivers know when "later" is?  This is why
I can't believe there is not some kind of "some USB resources have
been freed" event of some sort which USB drivers can use to deal with
this.  :-)